You are given an m x n
binary matrix mat
of 1
's (representing soldiers) and 0
's (representing civilians). The soldiers are positioned in front of the civilians. That is, all the 1
's will appear to the left of all the 0
's in each row.
A row i
is weaker than a row j
if one of the following is true:
- The number of soldiers in row
i
is less than the number of soldiers in rowj
. - Both rows have the same number of soldiers and
i < j
.
Return the indices of the k
weakest rows in the matrix ordered from weakest to strongest.
Example 1:
Input: mat = [[1,1,0,0,0], [1,1,1,1,0], [1,0,0,0,0], [1,1,0,0,0], [1,1,1,1,1]], k = 3 Output: [2,0,3] Explanation: The number of soldiers in each row is: - Row 0: 2 - Row 1: 4 - Row 2: 1 - Row 3: 2 - Row 4: 5 The rows ordered from weakest to strongest are [2,0,3,1,4].
Example 2:
Input: mat = [[1,0,0,0], [1,1,1,1], [1,0,0,0], [1,0,0,0]], k = 2 Output: [0,2] Explanation: The number of soldiers in each row is: - Row 0: 1 - Row 1: 4 - Row 2: 1 - Row 3: 1 The rows ordered from weakest to strongest are [0,2,3,1].
Constraints:
m == mat.length
n == mat[i].length
2 <= n, m <= 100
1 <= k <= m
matrix[i][j]
is either 0 or 1.
Related Topics:
Array, Binary Search, Sorting, Heap (Priority Queue), Matrix
// OJ: https://leetcode.com/problems/the-k-weakest-rows-in-a-matrix/
// Author: github.com/lzl124631x
// Time: O(MlogN + MlogM)
// Space: O(M)
class Solution {
public:
vector<int> kWeakestRows(vector<vector<int>>& A, int k) {
vector<pair<int, int>> B;
int M = A.size(), N = A[0].size();
for (int i = 0; i < M; ++i) {
int L = 0, R = N - 1;
while (L <= R) {
int M = (L + R) / 2;
if (A[i][M] == 1) L = M + 1;
else R = M - 1;
}
B.emplace_back(R, i);
}
sort(begin(B), end(B));
vector<int> ans;
for (int i = 0; i < k; ++i) ans.push_back(B[i].second);
return ans;
}
};
Or
// OJ: https://leetcode.com/problems/the-k-weakest-rows-in-a-matrix
// Author: github.com/lzl124631x
// Time: O(MlogN + MlogM)
// Space: O(M)
class Solution {
public:
vector<int> kWeakestRows(vector<vector<int>>& A, int k) {
int M = A.size(), N = A[0].size();
vector<int> cnt(M), id(M), ans(k);
for (int i = 0; i < M; ++i) {
int L = 0, R = N - 1;
while (L <= R) {
int M = (L + R) / 2;
if (A[i][M] == 1) L = M + 1;
else R = M - 1;
}
cnt[i] = L;
}
iota(begin(id), end(id), 0);
sort(begin(id), end(id), [&](int a, int b) { return cnt[a] != cnt[b] ? cnt[a] < cnt[b] : a < b; });
for (int i = 0; i < k; ++i) ans[i] = id[i];
return ans;
}
};
// OJ: https://leetcode.com/problems/the-k-weakest-rows-in-a-matrix/
// Author: github.com/lzl124631x
// Time: O(MlogN + MlogM)
// Space: O(M)
class Solution {
public:
vector<int> kWeakestRows(vector<vector<int>>& A, int k) {
vector<pair<int, int>> B;
int M = A.size(), N = A[0].size();
for (int i = 0; i < M; ++i) {
int L = 0, R = N; // Note that since we are looking for the first index of `0`, the `R` should be initialized as `N`.
while (L < R) {
int M = (L + R) / 2;
if (A[i][M] == 1) L = M + 1;
else R = M;
}
B.emplace_back(R, i);
}
sort(begin(B), end(B));
vector<int> ans;
for (int i = 0; i < k; ++i) ans.push_back(B[i].second);
return ans;
}
};
// OJ: https://leetcode.com/problems/the-k-weakest-rows-in-a-matrix
// Author: github.com/lzl124631x
// Time: O(M * (logN + logK))
// Space: O(K)
class Solution {
public:
vector<int> kWeakestRows(vector<vector<int>>& A, int k) {
int M = A.size(), N = A[0].size();
vector<int> ans;
typedef pair<int, int> PII; // cnt, index
priority_queue<PII> pq;
for (int i = 0; i < M; ++i) {
int L = 0, R = N - 1;
while (L <= R) {
int M = (L + R) / 2;
if (A[i][M] == 1) L = M + 1;
else R = M - 1;
}
pq.emplace(L, i);
if (pq.size() > k) pq.pop();
}
while (pq.size()) {
ans.push_back(pq.top().second);
pq.pop();
}
reverse(begin(ans), end(ans));
return ans;
}
};